package upload

import (
	"bytes"
	"context"
	"errors"
	"io"
	"mime"
	"mime/multipart"
	"path/filepath"
	"strings"
	"time"

	"kra/pkg/utils"

	"github.com/minio/minio-go/v7"
	"github.com/minio/minio-go/v7/pkg/credentials"
)

var MinioClient *Minio // 优化性能，但是不支持动态配置

// Minio MinIO存储
type Minio struct {
	Client    *minio.Client
	Bucket    string
	BasePath  string
	BucketURL string
}

// NewMinio 创建MinIO
func NewMinio(accessKeyID, accessKeySecret, bucket, endpoint, basePath string, useSSL bool) *Minio {
	if MinioClient != nil {
		return MinioClient
	}
	return &Minio{
		Bucket:   bucket,
		BasePath: basePath,
	}
}

// GetMinio 获取MinIO客户端实例
func GetMinio(endpoint, accessKeyID, accessKeySecret, bucketName string, useSSL bool) (*Minio, error) {
	if MinioClient != nil {
		return MinioClient, nil
	}
	// Initialize minio client object.
	minioClient, err := minio.New(endpoint, &minio.Options{
		Creds:  credentials.NewStaticV4(accessKeyID, accessKeySecret, ""),
		Secure: useSSL,
	})
	if err != nil {
		return nil, err
	}
	// 尝试创建bucket
	err = minioClient.MakeBucket(context.Background(), bucketName, minio.MakeBucketOptions{})
	if err != nil {
		// Check to see if we already own this bucket (which happens if you run this twice)
		exists, errBucketExists := minioClient.BucketExists(context.Background(), bucketName)
		if errBucketExists == nil && exists {
			// log.Printf("We already own %s\n", bucketName)
		} else {
			return nil, err
		}
	}
	MinioClient = &Minio{Client: minioClient, Bucket: bucketName}
	return MinioClient, nil
}

// UploadFile 上传文件
func (m *Minio) UploadFile(file *multipart.FileHeader) (string, string, error) {
	f, openError := file.Open()
	if openError != nil {
		return "", "", errors.New("function file.Open() Failed, err:" + openError.Error())
	}

	filecontent := bytes.Buffer{}
	_, err := io.Copy(&filecontent, f)
	if err != nil {
		return "", "", errors.New("读取文件失败, err:" + err.Error())
	}
	f.Close()

	// 对文件名进行加密存储
	ext := filepath.Ext(file.Filename)
	filename := utils.MD5V([]byte(strings.TrimSuffix(file.Filename, ext))) + ext
	var filePathRes string
	if m.BasePath == "" {
		filePathRes = "uploads" + "/" + time.Now().Format("2006-01-02") + "/" + filename
	} else {
		filePathRes = m.BasePath + "/" + time.Now().Format("2006-01-02") + "/" + filename
	}

	// 根据文件扩展名检测 MIME 类型
	contentType := mime.TypeByExtension(ext)
	if contentType == "" {
		contentType = "application/octet-stream"
	}

	// 设置超时10分钟
	ctx, cancel := context.WithTimeout(context.Background(), time.Minute*10)
	defer cancel()

	// Upload the file with PutObject   大文件自动切换为分片上传
	info, err := m.Client.PutObject(ctx, m.Bucket, filePathRes, &filecontent, file.Size, minio.PutObjectOptions{ContentType: contentType})
	if err != nil {
		return "", "", errors.New("上传文件到minio失败, err:" + err.Error())
	}
	return m.BucketURL + "/" + info.Key, filePathRes, nil
}

// DeleteFile 删除文件
func (m *Minio) DeleteFile(key string) error {
	ctx, cancel := context.WithTimeout(context.Background(), time.Second*5)
	defer cancel()

	// Delete the object from MinIO
	err := m.Client.RemoveObject(ctx, m.Bucket, key, minio.RemoveObjectOptions{})
	return err
}
